#include "MeshLoaders/AneuMeshLoader.h"
#include "MeshLoaders/NeuMeshLoader.h"
#include <iostream>

int main(int argc, char **argv) {
  AneuMeshLoader loader;
  //loader.LoadMesh(argv[1]);
  loader.LoadMesh("../test.aneu");
  auto result1 = loader.GetFiniteElementsByNodesId(66, 65, 324);
  std::ranges::for_each(result1, [](const int &elemId) { std::cout << elemId << ' '; });
  std::cout << std::endl;
  std::cout << std::endl;

  result1 = loader.GetFiniteElementsByEdge(65, 66);
  //std::cout << result1;
  std::ranges::for_each(result1, [](const int &elemId) { std::cout << elemId << ' '; });
  std::cout << std::endl;
  std::cout << std::endl;

  result1 = loader.GetBboundaryFiniteElementsBySurfaceId(1);
  std::ranges::for_each(result1, [](const int &elemId) { std::cout << elemId << ' '; });
  std::cout << std::endl;
  std::cout << std::endl;

  result1 = loader.GetFiniteElementsByMaterialId(1);
  std::ranges::for_each(result1, [](const int &elemId) { std::cout << elemId << ' '; });
  std::cout << std::endl;
  std::cout << std::endl;

  auto allBoundary = loader.GetBoundaryFiniteElements();
  loader.SortByMinAngle();

  std::ofstream outputStream("result.txt", std::ios::out);

  auto indexasion = [](const BoundaryFiniteElement &elem) {
    return elem.nodesId;
  };

  auto outputResult = allBoundary | std::ranges::views::transform(indexasion)
      | std::ranges::views::drop(10)
      | std::ranges::views::take(10);

    //!!! Нужно использовать сразу copy, и выводить в поток vector<int>, перегрузив << для него.
  std::ranges::for_each(outputResult,
                        [&outputStream](const auto &elem) {
                          std::ranges::copy(elem,
                                            std::ostream_iterator<int>(outputStream, "\t"));
                        });

  return 0;
}
